//http://seta43.hol.es/electro.html
//xsetaseta@gmail.com
//Libreria RF24master  2011 J. Coliz <maniacbug@ymail.com>
// Puerta Codigo lista
//28/02/2018

//#define DEBUG 

byte CODIGO2;
byte LISTAcodigo0[15]={12,9,5,11,8,6,13,4,1,0,7,2,14,3,10};
byte LISTAcodigo1[15]={13,0,5,2,11,9,4,12,6,1,8,10,7,14,3};

#define DIGIE  2  //Seleccin pin de puerta

#include <SPI.h> 
#include <nRF24L01.h>
#include <RF24.h>

#define CE 8
#define CSN 7

RF24 radio(CE, CSN);

const uint64_t tuberia = 0xE8E8F0F0E1LL;
byte dato[10];
int time1;
bool done;

byte x,y;
unsigned int codigo;

unsigned long time;

void setup() 
{
  Serial.begin(9600);
  Serial.print("____Puerta Lista____");
  radio.begin(); 
  radio.setChannel(50); 	
  radio.openReadingPipe(1, tuberia); 
  radio.startListening();  

  pinMode(DIGIE, OUTPUT);
  digitalWrite(DIGIE,LOW);

  CODIGO2=0;
  pinMode(3, INPUT);
  pinMode(4, INPUT);
  pinMode(5, INPUT);
  pinMode(6, INPUT);
  delay(100);
  if(digitalRead(3)) CODIGO2|=1;
  if(digitalRead(4)) CODIGO2|=2; 
  if(digitalRead(5)) CODIGO2|=4; 
  if(digitalRead(6)) CODIGO2|=8;
  Serial.println(CODIGO2); 
}


void loop() 
{
  delay(1);
  time1++;

  if(time1>4000)
  {
    time1=0;
    radio.openReadingPipe(1, tuberia); 
    radio.startListening(); 
  }

  while(radio.available()) 
  {
    radio.read(dato, 7);               
    done=1; 
  }

  if (done)
  { 
#ifdef DEBUG 
    Serial.print("CODIGO_P ");  
    Serial.print(dato[0]);  Serial.print("  "); Serial.print(dato[1]);   
    Serial.print("  ");  Serial.print(dato[2]);   Serial.print("  "); 
    Serial.print(dato[3]);  Serial.print("  ");  Serial.println(dato[4]); 
#endif    
    if( 0==dato[1] && 1==dato[2])  //Peticion de apertura
    {
      time1=0; //inicia tiempo en apertura
      Serial.println("Peticion de apertura");
      delay(300);
      radio.stopListening();
      radio.openWritingPipe(tuberia);
      dato[1]=dato[0]; //Numero de llave de peticion
      dato[0]=0;
      dato[2]=1;    //Codigo pregunta
      time = millis();
      x=time & 0x0F;
      y= 0x0F & (time>>8);
#ifdef DEBUG
      Serial.print("Codigo pregunta "); Serial.print(x); Serial.print("  "); Serial.println(y);
 #endif       
      dato[3]=x;  //codigo x
      dato[4]=y;  //codigo y
      enviarS();
      delay(30);
      radio.openReadingPipe(1, tuberia); 
      radio.startListening();
      goto salto; 
    }
    if( 0==dato[1] && 3==dato[2])  //Respuesta a pregunta de peticion de apertura
    {
      x=(x+CODIGO2) & 0x0F;    
      x=LISTAcodigo0[x];
      
      y=(y+CODIGO2) & 0x0F;
      y=LISTAcodigo1[y];
 #ifdef DEBUG      
      Serial.print("Respuesta "); Serial.print(dato[3]); Serial.print("  "); Serial.println(dato[4]);     
      Serial.print("Respuesta solicitada ");  Serial.print(x); Serial.print("  "); Serial.println(y); 
 #endif 
      if( dato[3]==x && dato[4]==y )
       {
        Serial.println("CORRECTO "); 
        digitalWrite(DIGIE,HIGH);
        delay(2000);
        digitalWrite(DIGIE,LOW); 
       }
       else
       {
        Serial.println("ERROR ");
        while(radio.available())     radio.read(dato, 7);               
        delay(5000);
       }     
    }
salto:
    done=0;
  }  
}



void enviarS()
{
  radio.write(dato, 7); 
  delay(10);
}




